Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
'
'frmMain
'
Me.AutoScale = False
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.BackColor = System.Drawing.Color.Black
Me.ClientSize = New System.Drawing.Size(392, 334)
Me.ControlBox = False
Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
Me.MaximizeBox = False
Me.MinimizeBox = False
Me.Name = "frmMain"
Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
Me.Text = "DirectX 9"

    End Sub

#End Region

  Private engine As clsEngine
  Private running As Boolean

  Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim frmEnum As New frmEnumeration()
    frmEnum.ShowDialog()

    If frmEnum.Cancel Then Me.Close() : Return
    If frmEnum.DevWidth = 0 Then
      engine = New clsEngine(Me)
    Else
      engine = New clsEngine(Me, frmEnum.DevWidth, frmEnum.DevHeight, frmEnum.DevDepth)
    End If
    ' ...
    If engine.Init Then running = True Else Me.Close()

    Dim t As New Threading.Thread(AddressOf Render)
    t.Start()
  End Sub

  Private Sub Render()
    Do While running
      Try

        engine.UpdateFrame()
        engine.RenderFrame()
      Catch stopexp As Threading.ThreadAbortException
        Return
      End Try
    Loop
  End Sub

  Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
    running = False
  End Sub

  Private Sub frmMain_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
    If e.KeyData = Keys.Escape Then Me.Close()
    If e.KeyData = Keys.T Then engine.Transparent = Not engine.Transparent
  End Sub
End Class
